<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_Description ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_Description extends AbstractStructArrayBase
{
    /**
     * The Description
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_Description[]
     */
    public $Description;
    /**
     * Constructor method for ArrayOfJP_Description
     * @uses ArrayOfJP_Description::setDescription()
     * @param \StructType\JP_Description[] $description
     */
    public function __construct(array $description = array())
    {
        $this
            ->setDescription($description);
    }
    /**
     * Get Description value
     * @return \StructType\JP_Description[]|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Description[] $description
     * @return \ArrayType\ArrayOfJP_Description
     */
    public function setDescription(array $description = array())
    {
        foreach ($description as $arrayOfJP_DescriptionDescriptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_DescriptionDescriptionItem instanceof \StructType\JP_Description) {
                throw new \InvalidArgumentException(sprintf('The Description property can only contain items of \StructType\JP_Description, "%s" given', is_object($arrayOfJP_DescriptionDescriptionItem) ? get_class($arrayOfJP_DescriptionDescriptionItem) : gettype($arrayOfJP_DescriptionDescriptionItem)), __LINE__);
            }
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Add item to Description value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_Description $item
     * @return \ArrayType\ArrayOfJP_Description
     */
    public function addToDescription(\StructType\JP_Description $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_Description) {
            throw new \InvalidArgumentException(sprintf('The Description property can only contain items of \StructType\JP_Description, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Description[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_Description|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_Description|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_Description|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_Description|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_Description|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Description
     */
    public function getAttributeName()
    {
        return 'Description';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_Description
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
